#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

const MAX = 7;

struct tree
{
	int num;
	struct tree* left;
	struct tree* right;
};

void init (struct tree** t)
{
	*t = NULL;
}

void set (struct tree** t, int x)
{
	*t = (struct tree*)malloc(sizeof(struct tree));
	(*t)->num = x;
	(*t)->right = NULL;
	(*t)->left = NULL;
}

void add (struct tree** t, int x)
{
	if (*t == NULL)
		set (t, x);
	else if (x < (*t)->num)
		add (&(*t)->left, x);
	else
		add (&(*t)->right, x);
}

void bulid_t (struct tree** t)
{
	int i, x;

	for (i = 0; i < MAX; i++)
	{
		x = random(30);
		add (t,x);
	}
}

void display_t (struct tree* t)
{
	if (t != NULL)
	{
		display_t (t->left);
		printf ("%d\t", t->num);
		display_t (t->right);
	}
	else
		return;
}

void del_t (struct tree** t)
{
	if (*t != NULL)
	{
		del_t (&(*t)->left);
		del_t (&(*t)->right);
		printf ("%p\t",*t);
		free (*t);
	}
	else
		return;
}

void main()
{
	struct tree* t;

	randomize();

	init (&t);
	bulid_t (&t);
	display_t (t);
	printf ("\nDeleting the tree in address %p :\n",&t);
	del_t (&t);
}